<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Exercises: Arraow Functions and Arrays</title>
</head>

<body>

    <script src="assets_accounts.js"></script>
    <script>
        console.log('Ex 1');
        let cust1 = accounts.find(account => account.number === 'EE154770478');
        console.log(cust1);

        console.log('Ex 2');
        let cust2 = accounts.find(account => account.number === 'LT937416401');
        console.log(cust2);

        console.log('Ex 3');
        let accountExists = accounts.some(a => a.number === 'LV587816561');
        console.log(accountExists);

        console.log('Ex 4');
        let accountExists2 = accounts.some(a => a.number === 'EE251446912');
        console.log(accountExists2);

        console.log('Ex 5');
        let richCustomers = accounts.filter(a => a.balance > 500);
        console.log(richCustomers);

        console.log('Ex 6');
        console.log('Variant 1');
        let totalBalance = accounts
            .filter(a => a.balance > 1000)
            .reduce(
                (currentTotal, currentCustomer) => {
                    return currentTotal + currentCustomer.balance
                },
                0
            );
        console.log(totalBalance);

        console.log('Variant 2');
        totalBalance = 0;
        for (let account of accounts) {
            if (account.balance > 1000) {
                totalBalance = totalBalance + account.balance;
            }
        }
        console.log(totalBalance);

        console.log('Variant 3');
        totalBalance = 0;
        for (let i = 0; i < accounts.length; i++) {
            if (accounts[i].balance > 1000) {
                totalBalance = totalBalance + accounts[i].balance;
            }
        }
        console.log(totalBalance);

        console.log('Variant 4');
        totalBalance = 0;
        accounts
            .filter(account => account.balance > 1000)
            .forEach(account => {
                totalBalance = totalBalance + account.balance;
            });
        console.log(totalBalance);

        console.log('Ex 11');
        accounts
            .filter(a => a.number.startsWith('LT'))
            .forEach(a => console.log(a.firstName + ' ' + a.lastName));

        console.log('Ex 12');
        let poorLatviansExist = accounts
            .some(a => a.number.startsWith('LV') && a.balance < 100);
        console.log(poorLatviansExist);

        console.log('Ex 13');
        let noBankruptedCustomers = accounts.every(a => a.balance >= 1);
        console.log(noBankruptedCustomers);

    </script>
</body>

</html>